module Main where

import Parser
import SML
import System

main :: IO ()
main = do [fileName1, fileName2] <- getArgs
          file1 <- readFile fileName1
          file2 <- readFile fileName2
          let doc1 = mainParser file1
          let doc2 = mainParser file2
          let gen1 = meaning rootContext rootContext doc1 False
          let gen2 = meaning rootContext rootContext doc2 False
--            putStrLn (map fst gen1)
--            putStrLn (map fst gen2)
          let len1 = length file1
          let len2 = length file2
          let ratio = if len1 == len2 || len2 == 0 then 100 else (len2 * 100) `div` len1
          putStr (fileName1 ++ ": " ++ show len1 ++ " vs. " ++ show len2 ++ ", " ++ show ratio ++ "% => ")
          compareGen (zip [0..] gen1) (zip [0..] gen2)

compareGen :: [(Int, (Char, Context))] -> [(Int, (Char, Context))] -> IO ()
compareGen [] [] = do putStrLn "OK"
compareGen (n1@(p1, (ch1, ctx1)):rest1) (n2@(p2, (ch2, ctx2)):rest2)
    | ch1 /= ch2 || ctx1 /= ctx2
        = do putStrLn ("DIFFERENT at char: " ++ show n1 ++ ";" ++ show n2)
             exitFailure
    | otherwise = compareGen rest1 rest2
compareGen (n1@(p1, (ch1, ctx1)):rest) [] 
    = do putStrLn ("DIFFERENT doc2 truncated: " ++ show n1)
         exitFailure
compareGen  [] (n1@(p1, (ch1, ctx1)):rest)
    = do putStrLn ("DIFFERENT doc1 truncated: " ++ show n1)
         exitFailure
