#!/bin/sh

# Set comparator program
if [ -z "$1" ]; then
    COMPARATOR="java -classpath . CompareDocs"
else
    COMPARATOR=$1
fi

if [ -z "$2" ]; then
    TIMEOUT="$2"
else
    TIMEOUT=180
fi

TESTFILE=`mktemp /tmp/randtest.XXXXXX` || exit 1

# Loop 'n' test
while [ 1 ]; do

    java -classpath . GenDocs > $TESTFILE.in
    ../runme $TIMEOUT < $TESTFILE.in > $TESTFILE.out 2> /dev/null
    $COMPARATOR $TESTFILE.in $TESTFILE.out
    if [ "$?" = "1" ]; then
        FAILUREFILE=failures/failure-`date +%s`
        mv $TESTFILE.in $FAILUREFILE.in
        mv $TESTFILE.out $FAILUREFILE.out
    fi

    rm -f $TESTFILE.in
    rm -f $TESTFILE.out

done
