#!/bin/sh

clear

if [ ! -z "$*" ]; then
    FILES="$*"
else
    FILES=*.in
    FAILFILES=failures/*.in
fi

# Save old stats
if [ -e "testall.stats" ]; then
    mv testall.stats testall.stats.prev
fi

echo "" > testall.stats

COMPARATOR="../source/validator"
#COMPARATOR="java -classpath . CompareDocs"

TOTAL=0
for i in $FILES $FAILFILES; do
    OUT=`dirname $i`/`basename $i .in`.out
    ../runme 180 < $i > $OUT 2> /dev/null
    LINE=`$COMPARATOR $i $OUT`
    echo $LINE
    echo "$LINE" >> testall.stats
    TOTAL=`expr $TOTAL + 1`
done

echo "Ran $TOTAL tests."

if [ -e "testall.stats.prev" ]; then
    echo ""
    echo "Results diff:"
    diff testall.stats.prev testall.stats
fi
echo "Done."
